diff --git a/game/client/src/main/java/net/minecraft/client/render/tessellator/TessellatorTerrainImpl.java b/game/client/src/main/java/net/minecraft/client/render/tessellator/TessellatorTerrainImpl.java
index d898f2e42..b75834a5c 100644
--- a/game/client/src/main/java/net/minecraft/client/render/tessellator/TessellatorTerrainImpl.java
+++ b/game/client/src/main/java/net/minecraft/client/render/tessellator/TessellatorTerrainImpl.java
@@ -20,6 +20,7 @@ public class TessellatorTerrainImpl implements TessellatorGeneral {
 
 
     public final @NotNull TerrainVertexData data;
+    private final int vertSize;
 
     public boolean drawing;
 
@@ -43,6 +44,7 @@ public class TessellatorTerrainImpl implements TessellatorGeneral {
 
     public TessellatorTerrainImpl(final int bufferSize) {
         this.data = new TerrainVertexData(bufferSize);
+        this.vertSize = this.data.config.getVertexSize();
     }
 
     @Override
@@ -78,62 +80,27 @@ public class TessellatorTerrainImpl implements TessellatorGeneral {
     @Override
     public void addVertex(final double x, final double y, final double z) {
         this.checkIsDrawing();
+        this.data.resizeIfNeeded(256);
 
-        int index = this.quadVertCount % 4;
-        this.quadPoses[index * 3] = this.offsetX + x;
-        this.quadPoses[index * 3 + 1] = this.offsetY + y;
-        this.quadPoses[index * 3 + 2] = this.offsetZ + z;
+        var buffer = this.data.getBuffer();
 
-        this.quadColors[index] = this.color;
+        buffer.putFloat((float) (this.offsetX + x)).putFloat((float) (this.offsetY + y)).putFloat((float) (this.offsetZ + z));
+        buffer.put((byte) Color.blueFromInt(this.color)).put((byte) Color.greenFromInt(this.color)).put((byte) Color.redFromInt(this.color));
+        buffer.put(this.normalX).put(this.normalY).put(this.normalZ);
 
-        this.quadUVs[index * 2] = (float) this.textureU;
-        this.quadUVs[index * 2 + 1] = (float) this.textureV;
+        buffer.putFloat((float) this.textureU).putFloat((float) this.textureV);
+        buffer.put(this.shade).put(this.lightIndex);
 
-        this.quadLightMap[index] = this.lightIndex;
-        this.quadShade[index] = this.shade;
+        this.data.vertexCount++;
 
-        this.quadNormals[index * 3] = this.normalX;
-        this.quadNormals[index * 3 + 1] = this.normalY;
-        this.quadNormals[index * 3 + 2] = this.normalZ;
+        if ((this.quadVertCount & 0b11) == 2) {
+            buffer.put(buffer.position(), buffer, buffer.position() - this.vertSize * 3, this.vertSize);
+            buffer.put(buffer.position() + this.vertSize, buffer, buffer.position() - this.vertSize, this.vertSize);
+            buffer.position(buffer.position() + this.vertSize * 2);
+            this.data.vertexCount += 2;
+        }
 
         this.quadVertCount++;
-
-        if (index == 3) { // Emit compressed quad
-            this.data.resizeIfNeeded(128);
-            ByteBuffer buffer = this.data.getBuffer();
-
-            double spX = this.quadPoses[0];
-            double spY = this.quadPoses[1];
-            double spZ = this.quadPoses[2];
-
-            // Average normals for quad
-            byte nX = (byte) ((this.quadNormals[0] + this.quadNormals[3] + this.quadNormals[6] + this.quadNormals[9])/4);
-            byte nY = (byte) ((this.quadNormals[1] + this.quadNormals[4] + this.quadNormals[7] + this.quadNormals[10])/4);
-            byte nZ = (byte) ((this.quadNormals[2] + this.quadNormals[5] + this.quadNormals[8] + this.quadNormals[11])/4);
-
-            int color = this.quadColors[0];
-
-            buffer.putFloat((float) spX).putFloat((float) spY).putFloat((float) spZ);
-            buffer.put((byte) Color.blueFromInt(color)).put((byte) Color.greenFromInt(color)).put((byte) Color.redFromInt(color));
-            buffer.put(nX).put(nY).put(nZ);
-
-            buffer.putShort((short) (this.quadUVs[0] * 0xFFFF)).putShort((short) (this.quadUVs[1] * 0xFFFF));
-            buffer.put(this.quadShade[0]).put(this.quadLightMap[0]);
-
-            buffer.putShort(MathHelper.toHalfFloat((float) (this.quadPoses[3] - spX))).putShort(MathHelper.toHalfFloat((float) (this.quadPoses[4] - spY))).putShort(MathHelper.toHalfFloat((float) (this.quadPoses[5] - spZ)));
-            buffer.putShort((short) (this.quadUVs[2] * 0xFFFF)).putShort((short) (this.quadUVs[3] * 0xFFFF));
-            buffer.put(this.quadShade[1]).put(this.quadLightMap[1]);
-
-            buffer.putShort(MathHelper.toHalfFloat((float) (this.quadPoses[6] - spX))).putShort(MathHelper.toHalfFloat((float) (this.quadPoses[7] - spY))).putShort(MathHelper.toHalfFloat((float) (this.quadPoses[8] - spZ)));
-            buffer.putShort((short) (this.quadUVs[4] * 0xFFFF)).putShort((short) (this.quadUVs[5] * 0xFFFF));
-            buffer.put(this.quadShade[2]).put(this.quadLightMap[2]);
-
-            buffer.putShort(MathHelper.toHalfFloat((float) (this.quadPoses[9] - spX))).putShort(MathHelper.toHalfFloat((float) (this.quadPoses[10] - spY))).putShort(MathHelper.toHalfFloat((float) (this.quadPoses[11] - spZ)));
-            buffer.putShort((short) (this.quadUVs[6] * 0xFFFF)).putShort((short) (this.quadUVs[7] * 0xFFFF));
-            buffer.put(this.quadShade[3]).put(this.quadLightMap[3]);
-
-            this.data.vertexCount++;
-        }
     }
 
     @Override
@@ -204,11 +171,12 @@ public class TessellatorTerrainImpl implements TessellatorGeneral {
 
     private int getUncompressVertexSize() {
         int size = 0;
-        size += Float.BYTES * 3;
-        size += Byte.BYTES * 4;
-        size += Float.BYTES * 2;
-        size += Byte.BYTES;
-        size += Byte.BYTES * 3;
+        size += 3 * Float.BYTES; // Pos
+        size += 3; // Color
+        size += 3; // Normal
+
+        size += 2 * Float.BYTES; // UV
+        size += 2; // LightShade
         return size;
     }
 
@@ -228,7 +196,7 @@ public class TessellatorTerrainImpl implements TessellatorGeneral {
     public static class TerrainVertexConfig implements VertexConfig<TerrainVertexConfig> {
         @Override
         public @NotNull DrawMode drawMode() {
-            return DrawMode.POINTS;
+            return DrawMode.TRIANGLES;
         }
 
         public void enable(final int vao, final int vbo) {
@@ -237,24 +205,11 @@ public class TessellatorTerrainImpl implements TessellatorGeneral {
 
             final int vertexSize = this.getVertexSize();
             int offset = 0;
-            GL41.glVertexAttribPointer(0, 3, GL41.GL_FLOAT, false, vertexSize, offset); offset += 3 * Float.BYTES; // Source Pos
-            GL41.glVertexAttribPointer(1, 3, GL41.GL_UNSIGNED_BYTE, true, vertexSize, offset); offset += 3; // Source Color
-            GL41.glVertexAttribPointer(2, 3, GL41.GL_BYTE, true, vertexSize, offset); offset += 3; // Source Normal
-
-            GL41.glVertexAttribPointer(3, 2, GL41.GL_UNSIGNED_SHORT, true, vertexSize, offset); offset += 2 * Short.BYTES; // V1 UV
-            GL41.glVertexAttribPointer(4, 2, GL41.GL_UNSIGNED_BYTE, false, vertexSize, offset); offset += 2; // V1 LightShade
-
-            GL41.glVertexAttribPointer(5, 3, GL41.GL_HALF_FLOAT, false, vertexSize, offset); offset += 3 * (Float.BYTES/2); // V2 Pos Offset
-            GL41.glVertexAttribPointer(6, 2, GL41.GL_UNSIGNED_SHORT, true, vertexSize, offset); offset += 2 * Short.BYTES; // V2 UV
-            GL41.glVertexAttribPointer(7, 2, GL41.GL_UNSIGNED_BYTE, false, vertexSize, offset); offset += 2; // V2 LightShade
-
-            GL41.glVertexAttribPointer(8, 3, GL41.GL_HALF_FLOAT, false, vertexSize, offset); offset += 3 * (Float.BYTES/2); // V3 Pos Offset
-            GL41.glVertexAttribPointer(9, 2, GL41.GL_UNSIGNED_SHORT, true, vertexSize, offset); offset += 2 * Short.BYTES; // V3 UV
-            GL41.glVertexAttribPointer(10, 2, GL41.GL_UNSIGNED_BYTE, false, vertexSize, offset); offset += 2; // V3 LightShade
-
-            GL41.glVertexAttribPointer(11, 3, GL41.GL_HALF_FLOAT, false, vertexSize, offset); offset += 3 * (Float.BYTES/2); // V4 Pos Offset
-            GL41.glVertexAttribPointer(12, 2, GL41.GL_UNSIGNED_SHORT, true, vertexSize, offset); offset += 2 * Short.BYTES; // V4 UV
-            GL41.glVertexAttribPointer(13, 2, GL41.GL_UNSIGNED_BYTE, false, vertexSize, offset); offset += 2; // V4 LightShade
+            GL41.glVertexAttribPointer(0, 3, GL41.GL_FLOAT, false, vertexSize, offset); offset += 3 * Float.BYTES; // Pos
+            GL41.glVertexAttribPointer(1, 3, GL41.GL_UNSIGNED_BYTE, true, vertexSize, offset); offset += 3; // Color
+            GL41.glVertexAttribPointer(2, 3, GL41.GL_BYTE, true, vertexSize, offset); offset += 3; // Normal
+            GL41.glVertexAttribPointer(3, 2, GL41.GL_FLOAT, true, vertexSize, offset); offset += 2 * Float.BYTES; // UV
+            GL41.glVertexAttribPointer(4, 2, GL41.GL_UNSIGNED_BYTE, false, vertexSize, offset); offset += 2; // LightShade
 
             assert  offset == vertexSize;
 
@@ -263,15 +218,6 @@ public class TessellatorTerrainImpl implements TessellatorGeneral {
             GL41.glEnableVertexAttribArray(2);
             GL41.glEnableVertexAttribArray(3);
             GL41.glEnableVertexAttribArray(4);
-            GL41.glEnableVertexAttribArray(5);
-            GL41.glEnableVertexAttribArray(6);
-            GL41.glEnableVertexAttribArray(7);
-            GL41.glEnableVertexAttribArray(8);
-            GL41.glEnableVertexAttribArray(9);
-            GL41.glEnableVertexAttribArray(10);
-            GL41.glEnableVertexAttribArray(11);
-            GL41.glEnableVertexAttribArray(12);
-            GL41.glEnableVertexAttribArray(13);
         }
 
         public void disable() {
@@ -280,15 +226,6 @@ public class TessellatorTerrainImpl implements TessellatorGeneral {
             GL41.glDisableVertexAttribArray(2);
             GL41.glDisableVertexAttribArray(3);
             GL41.glDisableVertexAttribArray(4);
-            GL41.glDisableVertexAttribArray(5);
-            GL41.glDisableVertexAttribArray(6);
-            GL41.glDisableVertexAttribArray(7);
-            GL41.glDisableVertexAttribArray(8);
-            GL41.glDisableVertexAttribArray(9);
-            GL41.glDisableVertexAttribArray(10);
-            GL41.glDisableVertexAttribArray(11);
-            GL41.glDisableVertexAttribArray(12);
-            GL41.glDisableVertexAttribArray(13);
 
             GL41.glBindBuffer(GL41.GL_ARRAY_BUFFER, 0);
             GL41.glBindVertexArray(0);
@@ -296,24 +233,12 @@ public class TessellatorTerrainImpl implements TessellatorGeneral {
 
         public int getVertexSize() {
             int size = 0;
-            size += 3 * Float.BYTES; // Source Pos
-            size += 3; // Source Color
-            size += 3; // Source Normal
-
-            size += 2 * Short.BYTES; // V1 UV
-            size += 2; // V1 LightShade
-
-            size += 3 * (Float.BYTES/2); // V2 Pos Offset
-            size += 2 * Short.BYTES; // V2 UV
-            size += 2; // V2 LightShade
-
-            size += 3 * (Float.BYTES/2); // V3 Pos Offset
-            size += 2 * Short.BYTES; // V3 UV
-            size += 2; // V3 LightShade
+            size += 3 * Float.BYTES; // Pos
+            size += 3; // Color
+            size += 3; // Normal
 
-            size += 3 * (Float.BYTES/2); // V4 Pos Offset
-            size += 2 * Short.BYTES; // V4 UV
-            size += 2; // V4 LightShade
+            size += 2 * Float.BYTES; // UV
+            size += 2; // LightShade
             return size;
         }
 
diff --git a/game/client/src/main/java/org/useless/dragonfly/data/block/mojang/BlockModelMojangData.java b/game/client/src/main/java/org/useless/dragonfly/data/block/mojang/BlockModelMojangData.java
index e198d6534..2e0aec760 100644
--- a/game/client/src/main/java/org/useless/dragonfly/data/block/mojang/BlockModelMojangData.java
+++ b/game/client/src/main/java/org/useless/dragonfly/data/block/mojang/BlockModelMojangData.java
@@ -108,7 +108,7 @@ public class BlockModelMojangData implements BlockModelData {
         @NotNull final TexturePackList texturePackList,
         @NotNull final NamespaceID id,
         @Nullable final String parent,
-        final boolean ambientOcclusion,
+        final @Nullable Boolean ambientOcclusion,
         @Nullable final Integer renderLayer,
         @Nullable final Map<@NotNull String, @NotNull DisplayPos> displayPositions,
         @Nullable final Map<@NotNull String, @NotNull String> textures,
@@ -119,8 +119,8 @@ public class BlockModelMojangData implements BlockModelData {
         this.parent = parent;
         if (parent != null) {
             final BlockModelMojangData parentData = BlockModelMojangData.Cache.loadModelData(texturePackList, parent);
-            this.ambientOcclusion = ambientOcclusion;
             if (parentData != null) {
+                this.ambientOcclusion = ambientOcclusion == null ? parentData.ambientOcclusion : ambientOcclusion;
                 this.displayPositions = new HashMap<>();
                 this.textures = new HashMap<>();
                 this.particleIndices = new Object2IntArrayMap<>();
@@ -135,6 +135,7 @@ public class BlockModelMojangData implements BlockModelData {
                 if (parentData.particleIndices != null) this.particleIndices.putAll(parentData.particleIndices);
                 if (particleIndices != null) this.particleIndices.putAll(particleIndices);
             } else {
+                this.ambientOcclusion = ambientOcclusion == null ? DEFAULT_AMBIENT_OCCLUSION : ambientOcclusion;
                 this.displayPositions = displayPositions;
                 this.particleIndices = particleIndices;
                 this.renderLayer = renderLayer;
@@ -142,7 +143,7 @@ public class BlockModelMojangData implements BlockModelData {
                 this.elements = elements;
             }
         } else {
-            this.ambientOcclusion = ambientOcclusion;
+            this.ambientOcclusion = ambientOcclusion == null ? DEFAULT_AMBIENT_OCCLUSION : ambientOcclusion;
             this.displayPositions = displayPositions;
             this.particleIndices = particleIndices;
             this.renderLayer = renderLayer;
@@ -178,7 +179,7 @@ public class BlockModelMojangData implements BlockModelData {
     @SuppressWarnings("unused")
     public static class Builder {
         protected @Nullable String parent = DEFAULT_PARENT;
-        protected boolean ambientOcclusion = DEFAULT_AMBIENT_OCCLUSION;
+        protected @Nullable Boolean ambientOcclusion = null;
         protected @Nullable Integer renderLayer = null;
         protected @Nullable Map<@NotNull String, @NotNull DisplayPos> displayPosMap = null;
         protected @Nullable Map<@NotNull String, @NotNull String> textures = null;
@@ -190,7 +191,7 @@ public class BlockModelMojangData implements BlockModelData {
             return this;
         }
 
-        public @NotNull Builder setAO(final boolean ao) {
+        public @NotNull Builder setAO(final @Nullable Boolean ao) {
             this.ambientOcclusion = ao;
             return this;
         }
diff --git a/game/client/src/main/java/org/useless/dragonfly/models/block/mojang/StaticBlockModelMojang.java b/game/client/src/main/java/org/useless/dragonfly/models/block/mojang/StaticBlockModelMojang.java
index 6087bb80a..0b7b5cb8e 100644
--- a/game/client/src/main/java/org/useless/dragonfly/models/block/mojang/StaticBlockModelMojang.java
+++ b/game/client/src/main/java/org/useless/dragonfly/models/block/mojang/StaticBlockModelMojang.java
@@ -233,7 +233,7 @@ public class StaticBlockModelMojang implements StaticBlockModel {
                 }
 
                 final boolean useAO = this.compiled.data.ambientOcclusion && GameSettings.AMBIENT_OCCLUSION.value && element.shade;
-                final boolean isFullCube = depth <= FULL_CUBE_THRESHOLD && element.shade;
+                final boolean isFullCube = depth <= FULL_CUBE_THRESHOLD;
 
                 final float r;
                 final float g;
diff --git a/game/client/src/main/resources/assets/minecraft/textures/block/rubyglass/block_pure.png.mcmeta b/game/client/src/main/resources/assets/minecraft/textures/block/rubyglass/block_pure.png.mcmeta
new file mode 100644
index 000000000..af30dc0cf
--- /dev/null
+++ b/game/client/src/main/resources/assets/minecraft/textures/block/rubyglass/block_pure.png.mcmeta
@@ -0,0 +1,6 @@
+{
+  "animation": {
+    "interpolate": true,
+    "frametime": 16
+  }
+}
\ No newline at end of file
diff --git a/game/client/src/main/resources/assets/minecraft/textures/block/rubyglass/node.png.mcmeta b/game/client/src/main/resources/assets/minecraft/textures/block/rubyglass/node.png.mcmeta
new file mode 100644
index 000000000..af30dc0cf
--- /dev/null
+++ b/game/client/src/main/resources/assets/minecraft/textures/block/rubyglass/node.png.mcmeta
@@ -0,0 +1,6 @@
+{
+  "animation": {
+    "interpolate": true,
+    "frametime": 16
+  }
+}
\ No newline at end of file
diff --git a/game/client/src/main/resources/assets/minecraft/textures/block/water_overlay_boiling.png.mcmeta b/game/client/src/main/resources/assets/minecraft/textures/block/water_overlay_boiling.png.mcmeta
new file mode 100644
index 000000000..926199644
--- /dev/null
+++ b/game/client/src/main/resources/assets/minecraft/textures/block/water_overlay_boiling.png.mcmeta
@@ -0,0 +1,6 @@
+{
+  "animation": {
+    "interpolate": true,
+    "frametime": 3
+  }
+}
\ No newline at end of file
diff --git a/game/client/src/main/resources/shaders/post/post.fsh b/game/client/src/main/resources/shaders/post/post.fsh
index bc044ee4d..7bbf4f5df 100644
--- a/game/client/src/main/resources/shaders/post/post.fsh
+++ b/game/client/src/main/resources/shaders/post/post.fsh
@@ -124,7 +124,7 @@ void Bloom(inout vec3 color) {
 	
 	blur /= allStrengths;
 	
-	color.rgb *= 1.0 - (bloom * 0.1);
+	blur.rgb *= 1.0 - (bloom * 0.1);
 	color.rgb += blur.rgb * 0.15 * bloom;
 }
 
@@ -137,8 +137,8 @@ void HeatHaze(inout vec2 coord, float amount) {
 	vec2 wave = vec2(0.0, 0.0);
 	
 	float waveSize = 50;
-	wave.x += sin(coord.y * 1.3 * waveSize + frameTimeCounter * 10);
-	wave.x += sin(coord.y * 5.0 * waveSize + frameTimeCounter * 14);
+	wave.x += sin(coord.y * 1.3 * waveSize + frameTimeCounter * -10);
+	wave.x += sin(coord.y * 5.0 * waveSize + frameTimeCounter * -14);
 	wave.y += sin(coord.x * 1.0 * waveSize + frameTimeCounter * 5) * 2;
 	
 	coord += wave * strength * 0.0001;
diff --git a/game/client/src/main/resources/shaders/terrain.fsh b/game/client/src/main/resources/shaders/terrain.fsh
index 8c75124a7..e8c27cc5c 100644
--- a/game/client/src/main/resources/shaders/terrain.fsh
+++ b/game/client/src/main/resources/shaders/terrain.fsh
@@ -78,7 +78,10 @@ void main() {
 
     vec4 c = vec4(mix(vec3(1, 1, 1), Color.rgb, maskColor.r), 1) * uColor;
 
-    vec4 postColor = texColor * c * vec4(Shade, Shade, Shade, 1) * lightColor;
+    float shadeEffect = 1 - max(emissiveColor.r, emissiveColor.g);
+    float s = mix(1, Shade, shadeEffect);
+
+    vec4 postColor = texColor * c * vec4(s, s, s, 1) * lightColor;
     vec4 litColor = vec4(postColor.rgb * clamp(Light, 0, 1), postColor.a);
 //    vec4 litColor = vec4(abs(Norm), 1f);
 
diff --git a/game/client/src/main/resources/shaders/terrain.vsh b/game/client/src/main/resources/shaders/terrain.vsh
index 53d29cb43..15e3df320 100644
--- a/game/client/src/main/resources/shaders/terrain.vsh
+++ b/game/client/src/main/resources/shaders/terrain.vsh
@@ -1,64 +1,51 @@
 #version 410 core
-// Only guranteed 16 4 comp locations, so some attributes are packed together to save count, see (https://docs.gl/gl4/glGet @ GL_MAX_VERTEX_ATTRIBS)
-// Can combine uv and light shade in future if number needs further reduction
-layout (location = 0) in vec3 aSourcePos;
-layout (location = 1) in vec3 aSourceColor;
-layout (location = 2) in vec3 aSourceNormal;
 
-// Vertex one uses the position of the source pos
-layout (location = 3) in vec2 aV1UV;
-layout (location = 4) in vec2 aV1LightShade;
-
-layout (location = 5) in vec3 aV2PosOffset;
-layout (location = 6) in vec2 aV2UV;
-layout (location = 7) in vec2 aV2LightShade;
-
-layout (location = 8) in vec3 aV3PosOffset;
-layout (location = 9) in vec2 aV3UV;
-layout (location = 10) in vec2 aV3LightShade;
-
-layout (location = 11) in vec3 aV4PosOffset;
-layout (location = 12) in vec2 aV4UV;
-layout (location = 13) in vec2 aV4LightShade;
-
-out VS_OUT {
-    vec3 sourcePos;
-    vec3 sourceColor;
-    vec3 sourceNormal;
-
-    vec2 V1UV;
-    vec2 V1LightShade;
-
-    vec3 V2PosOffset;
-    vec2 V2UV;
-    vec2 V2LightShade;
-
-    vec3 V3PosOffset;
-    vec2 V3UV;
-    vec2 V3LightShade;
+layout (location = 0) in vec3 aPos;
+layout (location = 1) in vec3 aColor;
+layout (location = 2) in vec3 aNormal;
+layout (location = 3) in vec2 aUV;
+layout (location = 4) in vec2 aLightShade;
+
+uniform mat4 model;
+layout (std140) uniform Matrices {
+    mat4 projection;
+    mat4 projectionInv;
+    mat4 view;
+    mat4 viewInv;
+} matrices;
+
+uniform mat4 normalTransform;
+uniform vec4 lightModelAmbient;
+uniform vec4 lightSourcePosition1;
+uniform vec4 lightSourcePosition2;
+uniform vec4 lightSourceDiffuse1;
+uniform vec4 lightSourceDiffuse2;
+
+out vec4 Color;
+out float Shade;
+out vec2 TexCoord;
+out vec2 LightMapCoord;
+out vec3 Light;
+out vec4 Norm;
+
+vec2 unpackLightCoord(vec2 lightShade) {
+    int asInt = int(lightShade.y);
+    return vec2(((asInt & 0xF) + 0.5)/16.0, (((asInt & 0xF0) >> 4) + 0.5)/16.0);
+}
 
-    vec3 V4PosOffset;
-    vec2 V4UV;
-    vec2 V4LightShade;
-} vs_out;
+float unpackShade(vec2 lightShade) {
+    return lightShade.x/256;
+}
 
 void main() {
-    vs_out.sourcePos = aSourcePos;
-    vs_out.sourceColor = aSourceColor;
-    vs_out.sourceNormal = aSourceNormal;
-
-    vs_out.V1UV = aV1UV;
-    vs_out.V1LightShade = aV1LightShade;
-
-    vs_out.V2PosOffset = aV2PosOffset;
-    vs_out.V2UV = aV2UV;
-    vs_out.V2LightShade = aV2LightShade;
-
-    vs_out.V3PosOffset = aV3PosOffset;
-    vs_out.V3UV = aV3UV;
-    vs_out.V3LightShade = aV3LightShade;
-
-    vs_out.V4PosOffset = aV4PosOffset;
-    vs_out.V4UV = aV4UV;
-    vs_out.V4LightShade = aV4LightShade;
-}
+    Norm = normalize(normalTransform * model * vec4(aNormal, 0));
+    float dir1 = max(0.0, dot(Norm, lightSourcePosition1));
+    float dir2 = max(0.0, dot(Norm, lightSourcePosition2));
+    Light = (lightModelAmbient + lightSourceDiffuse1 * (dir1 + dir2)).xyz;
+
+    Color = vec4(aColor, 1);
+    Shade = unpackShade(aLightShade);
+    TexCoord = aUV;
+    LightMapCoord = unpackLightCoord(aLightShade);
+    gl_Position = matrices.projection * matrices.view * model * vec4(aPos, 1);
+}
\ No newline at end of file
diff --git a/game/client/src/main/resources/shaders/terrain.vsh.disabled b/game/client/src/main/resources/shaders/terrain.vsh.disabled
new file mode 100644
index 000000000..53d29cb43
--- /dev/null
+++ b/game/client/src/main/resources/shaders/terrain.vsh.disabled
@@ -0,0 +1,64 @@
+#version 410 core
+// Only guranteed 16 4 comp locations, so some attributes are packed together to save count, see (https://docs.gl/gl4/glGet @ GL_MAX_VERTEX_ATTRIBS)
+// Can combine uv and light shade in future if number needs further reduction
+layout (location = 0) in vec3 aSourcePos;
+layout (location = 1) in vec3 aSourceColor;
+layout (location = 2) in vec3 aSourceNormal;
+
+// Vertex one uses the position of the source pos
+layout (location = 3) in vec2 aV1UV;
+layout (location = 4) in vec2 aV1LightShade;
+
+layout (location = 5) in vec3 aV2PosOffset;
+layout (location = 6) in vec2 aV2UV;
+layout (location = 7) in vec2 aV2LightShade;
+
+layout (location = 8) in vec3 aV3PosOffset;
+layout (location = 9) in vec2 aV3UV;
+layout (location = 10) in vec2 aV3LightShade;
+
+layout (location = 11) in vec3 aV4PosOffset;
+layout (location = 12) in vec2 aV4UV;
+layout (location = 13) in vec2 aV4LightShade;
+
+out VS_OUT {
+    vec3 sourcePos;
+    vec3 sourceColor;
+    vec3 sourceNormal;
+
+    vec2 V1UV;
+    vec2 V1LightShade;
+
+    vec3 V2PosOffset;
+    vec2 V2UV;
+    vec2 V2LightShade;
+
+    vec3 V3PosOffset;
+    vec2 V3UV;
+    vec2 V3LightShade;
+
+    vec3 V4PosOffset;
+    vec2 V4UV;
+    vec2 V4LightShade;
+} vs_out;
+
+void main() {
+    vs_out.sourcePos = aSourcePos;
+    vs_out.sourceColor = aSourceColor;
+    vs_out.sourceNormal = aSourceNormal;
+
+    vs_out.V1UV = aV1UV;
+    vs_out.V1LightShade = aV1LightShade;
+
+    vs_out.V2PosOffset = aV2PosOffset;
+    vs_out.V2UV = aV2UV;
+    vs_out.V2LightShade = aV2LightShade;
+
+    vs_out.V3PosOffset = aV3PosOffset;
+    vs_out.V3UV = aV3UV;
+    vs_out.V3LightShade = aV3LightShade;
+
+    vs_out.V4PosOffset = aV4PosOffset;
+    vs_out.V4UV = aV4UV;
+    vs_out.V4LightShade = aV4LightShade;
+}
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicFluid.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicFluid.java
index 0859e3683..3406d37cc 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicFluid.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicFluid.java
@@ -24,7 +24,7 @@ import org.joml.primitives.AABBdc;
 import java.util.Random;
 
 public abstract class BlockLogicFluid extends BlockLogic {
-    protected final @NotNull Fluid fluid;
+    public final @NotNull Fluid fluid;
     protected static final Direction[] CHECK_HARDEN_DIRECTIONS = new Direction[] {Direction.NORTH, Direction.SOUTH, Direction.WEST, Direction.EAST, Direction.UP};
 
     public BlockLogicFluid(final @NotNull Block<?> block, final @NotNull Material material, final @NotNull Fluid fluid) {
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicOreRubyglass.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicOreRubyglass.java
new file mode 100644
index 000000000..8a32ca537
--- /dev/null
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicOreRubyglass.java
@@ -0,0 +1,29 @@
+package net.minecraft.core.block;
+
+import it.unimi.dsi.fastutil.ints.Int2IntArrayMap;
+import net.minecraft.core.block.entity.TileEntity;
+import net.minecraft.core.enums.EnumDropCause;
+import net.minecraft.core.item.ItemStack;
+import net.minecraft.core.item.Items;
+import net.minecraft.core.world.World;
+import org.jetbrains.annotations.NotNull;
+import org.jetbrains.annotations.Nullable;
+
+public class BlockLogicOreRubyglass extends BlockLogicRubyglass
+{
+    public static Int2IntArrayMap variantMap = new Int2IntArrayMap();
+
+    public BlockLogicOreRubyglass(@NotNull Block<?> block){
+        super(block);
+        variantMap.put(Blocks.RUBYGLASS_COLUMN.id(), block.id());
+    }
+
+    @Override
+    public ItemStack[] getBreakResult(@NotNull World world, @NotNull EnumDropCause dropCause, int data, @Nullable TileEntity tileEntity) {
+        return switch (dropCause) {
+            case SILK_TOUCH, PICK_BLOCK -> new ItemStack[]{new ItemStack(this)};
+            case EXPLOSION, PROPER_TOOL, PISTON_CRUSH -> new ItemStack[]{new ItemStack(Items.RUBYGLASS_CRYSTAL)};
+            default -> null;
+        };
+    }
+}
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicRubyglass.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicRubyglass.java
index 0f5b1f45c..6d879d1de 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicRubyglass.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicRubyglass.java
@@ -26,19 +26,6 @@ public class BlockLogicRubyglass extends BlockLogic
         block.setTicking(true);
     }
 
-    @Override
-    public ItemStack[] getBreakResult(@NotNull World world, @NotNull EnumDropCause dropCause, int meta, TileEntity tileEntity)
-    {
-        switch (dropCause)
-        {
-            case PICK_BLOCK:
-            case SILK_TOUCH:
-                return new ItemStack[] { new ItemStack(this) };
-            default:
-                return new ItemStack[] { new ItemStack(Items.RUBYGLASS_CRYSTAL_CRACKED, world.rand.nextInt(3)) };
-        }
-    }
-
     @Override
     public float getAmbientOcclusionStrength(final @NotNull WorldSource source, final @NotNull TilePosc tilePos) {
         return 0.0f;
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicRubyglassCrop.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicRubyglassCrop.java
index 5b7d27d88..49f8d4040 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicRubyglassCrop.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicRubyglassCrop.java
@@ -6,7 +6,6 @@ import net.minecraft.core.block.tag.BlockTags;
 import net.minecraft.core.enums.EnumDropCause;
 import net.minecraft.core.item.ItemStack;
 import net.minecraft.core.item.Items;
-import net.minecraft.core.world.Dimension;
 import net.minecraft.core.world.World;
 import net.minecraft.core.world.WorldSource;
 import net.minecraft.core.world.pos.TilePos;
@@ -143,9 +142,9 @@ public class BlockLogicRubyglassCrop extends BlockLogic {
     @Override
     public @NotNull ItemStack @Nullable [] getBreakResult(final @NotNull World world, final @NotNull EnumDropCause dropCause, final int data, final @Nullable TileEntity tileEntity) {
         if (data != MAX_GROWTH_STATE) {
-            return new ItemStack[] { new ItemStack(Items.RUBYGLASS_CRYSTAL_CRACKED) };
+            return new ItemStack[] { new ItemStack(Items.RUBYGLASS_DUST) };
         } else {
-            return new ItemStack[] { new ItemStack(Items.RUBYGLASS_CRYSTAL_PURE) };
+            return new ItemStack[] { new ItemStack(Items.RUBYGLASS_CRYSTAL) };
         }
     }
 
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicRubyglassGrowth.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicRubyglassSprout.java
similarity index 95%
rename from game/core/src/main/java/net/minecraft/core/block/BlockLogicRubyglassGrowth.java
rename to game/core/src/main/java/net/minecraft/core/block/BlockLogicRubyglassSprout.java
index 6c0b4c963..8f259f1b5 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicRubyglassGrowth.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicRubyglassSprout.java
@@ -2,8 +2,6 @@ package net.minecraft.core.block;
 
 import net.minecraft.core.block.entity.TileEntity;
 import net.minecraft.core.block.material.Materials;
-import net.minecraft.core.block.tag.BlockTags;
-import net.minecraft.core.data.tag.Tag;
 import net.minecraft.core.enums.EnumDropCause;
 import net.minecraft.core.item.ItemStack;
 import net.minecraft.core.item.Items;
@@ -17,8 +15,8 @@ import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
 import org.joml.primitives.AABBd;
 
-public class BlockLogicRubyglassGrowth extends BlockLogic {
-    public BlockLogicRubyglassGrowth(Block<?> block) {
+public class BlockLogicRubyglassSprout extends BlockLogic {
+    public BlockLogicRubyglassSprout(Block<?> block) {
         super(block, Materials.PLANT);
         block.setTicking(true);
     }
@@ -177,7 +175,11 @@ public class BlockLogicRubyglassGrowth extends BlockLogic {
 
     @Override
     public ItemStack[] getBreakResult(@NotNull World world, @NotNull EnumDropCause dropCause, int meta, TileEntity tileEntity) {
-        return new ItemStack[] { new ItemStack(Items.RUBYGLASS_CRYSTAL_CRACKED) };
+        // Buds have a 1/50 chance to drop pure Rubyglass.
+        if(world.rand.nextInt(50) == 0) {
+            return new ItemStack[] { new ItemStack(Items.RUBYGLASS_CRYSTAL) };
+        }
+        return null;
     }
 
     public static Direction metaToDirection(int meta) {
